-- Example of creating tablespaces
-- (13-Oct-2003) obsolete now 
--
CONNECT TO mystore USER username USING password;

-- Creating buffer pool for table space with 32K pages
CREATE BUFFERPOOL NEWBERN1BP SIZE 32 PAGESIZE 32 K ;

-- Now restart database
RESTART DATABASE mystore USER username USING password;

-- Change location and initial size, if desired

CREATE TABLESPACE NEWBERN2 MANAGED BY DATABASE USING (FILE 'd:\mystore\NEWBERN2' 50M) EXTENTSIZE 16 PREFETCHSIZE 16;

CREATE  REGULAR  TABLESPACE NEWBERN1 PAGESIZE 32 K  MANAGED BY DATABASE USING (FILE 'd:\mystore\NEWBERN1' 50M) EXTENTSIZE 4 PREFETCHSIZE 4 BUFFERPOOL NEWBERN1BP;

-- Optional: create temporary table space with 32K pages
-- CREATE TEMPORARY TABLESPACE TEMP32 PAGESIZE 32 K MANAGED BY SYSTEM USING ('C:\TEMP32') BUFFERPOOL NEWBERN1BP;

TERMINATE;
